#Region ;**** Directives created by AutoIt3Wrapper_GUI ****
#AutoIt3Wrapper_icon=SetupSource\icon.ico
#EndRegion ;**** Directives created by AutoIt3Wrapper_GUI ****
#include <GUIConstants.au3>
Global Const $WS_EX_CONTROLPARENT = 0x00010000

$defaultfoldername = "Vistumbler v.5.5" 
$VistumblerEXE = "Vistumbler v5.5.exe" 
$VistumblerShortcut = "Vistumbler v5.5.lnk" 

Dim $SetupFiles = "SetupFiles" 

DirCreate($SetupFiles)
FileInstall('SetupSource\blue.bmp', 'SetupFiles\blue.bmp')
FileInstall('SetupSource\icon.ico', 'SetupFiles\icon.ico')
FileInstall('SetupSource\mac_labels.ini', 'SetupFiles\mac_labels.ini')
FileInstall('SetupSource\new_ap.wav', 'SetupFiles\new_ap.wav')
FileInstall('SetupSource\Vistumbler v5.5.au3', 'SetupFiles\Vistumbler v5.5.au3')
FileInstall('SetupSource\Vistumbler v5.5.exe', 'SetupFiles\Vistumbler v5.5.exe')
FileInstall('SetupSource\vistumbler_settings.ini', 'SetupFiles\vistumbler_settings.ini')

$VistumblerInstaller = GUICreate("Vistumbler Setup", 583, 329, 193, 115)
$Pic1 = GUICtrlCreatePic("SetupFiles\blue.bmp", 8, 8, 164, 314, BitOR($SS_NOTIFY, $WS_GROUP))

$WelcomeChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$WelcomeEdit = GUICtrlCreateEdit("", 8, 8, 369, 265)
GUICtrlSetData(-1, "Welcome to the Vistumbler Installer. For updates, visit " & @CRLF & "http://techidiots.net/project-pages/vistumbler/" & @CRLF & @CRLF & 'Vistumbler is for personal use only. The user is reponsible if they use ' & @CRLF & 'this application in an improper way.'& @CRLF & @CRLF & 'Vistumbler is open source. All I ask is if you use my code, give ' & @CRLF & 'me credit in some way.'  & @CRLF & @CRLF &  'Click next only if you agree with these terms')
$WelcomeNext = GUICtrlCreateButton("&Next", 192, 280, 81, 25, 0)
$WelcomeCancle = GUICtrlCreateButton("&Cancle", 100, 280, 81, 25, 0)
GUISetState(@SW_SHOW)

$SaveChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$SaveInstall = GUICtrlCreateButton("&Install", 192, 280, 81, 25, 0)
$SaveCancle = GUICtrlCreateButton("&Cancle", 100, 280, 81, 25, 0)
GUICtrlCreateGroup("Where would you like to install vistumbler?", 8, 16, 369, 81)
$SaveInstallDir = GUICtrlCreateInput(@ProgramFilesDir & "\" & $defaultfoldername, 20, 46, 289, 21)
$SaveBrowse = GUICtrlCreateButton("Browse", 315, 44, 49, 17, 0)
GUICtrlCreateGroup("Would you like to make icons?", 8, 112, 369, 105)
$SaveDesktopIcon = GUICtrlCreateCheckbox("Add icon on desktop", 24, 144, 337, 17)
$SaveStartMenuIcon = GUICtrlCreateCheckbox("Add icon in start menu", 24, 176, 137, 17)
$SaveStartMenuFolder = GUICtrlCreateInput($defaultfoldername, 168, 176, 161, 21)
GUISetState(@SW_HIDE)

$ErrorChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$ErrorEdit = GUICtrlCreateEdit("", 8, 8, 369, 209)
GUICtrlSetData(-1, "An error has occured. Vistumbler was not installed properly")
$ErrorExit = GUICtrlCreateButton("E&xit", 150, 230, 81, 25, 0)
GUISetState(@SW_HIDE)

$DoneChild = GUICreate("", 400, 313, 176, 8, BitOR($WS_CHILD, $WS_TABSTOP), $WS_EX_CONTROLPARENT, $VistumblerInstaller)
$DoneEdit = GUICtrlCreateEdit("", 8, 8, 369, 209)
GUICtrlSetData(-1, "Vistumbler has succesfully installed")
$DoneExit = GUICtrlCreateButton("E&xit", 150, 230, 81, 25, 0)
GUISetState(@SW_HIDE)

GUISwitch($VistumblerInstaller)

GUISetState(@SW_SHOW)

While 1
	$nMsg = GUIGetMsg()
	Switch $nMsg
		Case $GUI_EVENT_CLOSE
			_ExitProgram()
		Case $WelcomeCancle
			_ExitProgram()
		Case $SaveCancle
			_ExitProgram()
		Case $ErrorExit
			_ExitProgram()
		Case $DoneExit
			_ExitProgram()
		Case $WelcomeNext
			GUISetState(@SW_SHOW, $SaveChild)
			GUISetState(@SW_HIDE, $WelcomeChild)
		Case $SaveInstall
			$DestinationDir = GUICtrlRead($SaveInstallDir)
			$StartMenuFolder = GUICtrlRead($SaveStartMenuFolder)
			DirRemove($DestinationDir, 1)
			;DirCreate($DestinationDir)
			If DirCopy($SetupFiles, $DestinationDir, 1) = 1 Then
				If GUICtrlRead($SaveDesktopIcon) = 1 Then
					FileCreateShortcut($DestinationDir & '\' & $VistumblerEXE, @DesktopDir & '\' & $VistumblerShortcut)
				EndIf
				If GUICtrlRead($SaveStartMenuIcon) = 1 Then
					DirCreate(@ProgramsDir & '\' & $StartMenuFolder)
					FileCreateShortcut($DestinationDir & '\' & $VistumblerEXE, @ProgramsDir & '\' & $StartMenuFolder & '\' & $VistumblerShortcut)
				EndIf
				GUISetState(@SW_SHOW, $DoneChild)
				GUISetState(@SW_HIDE, $SaveChild)
			Else
				GUISetState(@SW_SHOW, $ErrorChild)
				GUISetState(@SW_HIDE, $SaveChild)
			EndIf
		Case $SaveBrowse
			_Browse()
	EndSwitch
WEnd

Func _ExitProgram()
	DirRemove($SetupFiles, 1)
	Exit
EndFunc   ;==>_ExitProgram

Func _Browse()
	$newinstallfolder = FileSelectFolder ( "Install Dir", @ProgramFilesDir, 7)
	If Not @error then GUICtrlSetData($SaveInstallDir, $newinstallfolder)
EndFunc
